##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

#Globals
import Globals
import zLOG
import string
from AccessControl import ClassSecurityInfo
from DateTime.DateTime import DateTime

#CMF
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl

factory_type_information = {
      'id': 'Contact',
      'meta_type': 'PIM Contact',
      'description': 'Use contact object to store contact data',
      'product': 'OnlinePIM',
      'icon': 'profile_icon.gif',
      'factory': 'addContact',
      'filter_content_types': 0,
      'immediate_view': 'contact_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'contact_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'contact_edit_form',
		'permissions': ('Manage properties',),
		'category': 'object'})
       }


class Contact( PortalContent
          , DefaultDublinCoreImpl
          ):
    """
        A Contact object for storing contact information in.
    """

    meta_type='PIM Contact'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1

    security = ClassSecurityInfo()

    #Dumme values :-(
    firstname = ''
    showFirstname = ''
    lastname = ''
    showLastname = ''
    job_title = ''
    showJobtitle = ''
    company = ''
    showCompany = ''
    file_as = ''
    address = ''
    showAddress = ''
    phone = ''
    showPhone = ''
    pri_email = ''
    showPriemail = ''
    sec_email = ''
    showSecemail = ''
    ter_email = ''
    showTeremail = ''
    homepage = ''
    showHomepage = ''

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
        self.description=description
	self.firstname = ''
	self.showFirstname = 0
	self.lastname = ''
	self.showLastname = 0
	self.job_title = ''
	self.showJobtitle = 0
	self.company = ''
	self.showCompany = 0
	self.file_as = ''
	self.showFileAs = 0
	self.address = ''
	self.showAddress = 0
	self.phone = ''
	self.showPhone = 0
	self.pri_email = ''
	self.showPriemail = 0
	self.sec_email = ''
	self.showSecemail = 0
	self.ter_email = ''
	self.showTeremail = 0
	self.homepage = ''
	self.showHomepage = 0

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    security.declareProtected(ManageProperties, 'edit')
    def edit(self, title=None, description=None, firstname=None, showFirstname=None, lastname=None, showLastname=None, job_title=None, showJobtitle=None, company=None, showCompany=None, file_as=None, showFileAs=None, address=None, showAddress=None, phone=None, showPhone=None, pri_email=None, showPriemail=None, sec_email=None, showSecemail=None, ter_email=None, showTeremail=None, homepage=None, showHomepage=None):
        """
            Edit the properties of the contact.
            If fields are set to None, they will not be updated.
        """

	if title is not None:
	   self.setTitle(title)

	if description is not None:
	   self.setDescription(description)

	if firstname is not None:
	   self.firstname = firstname

	if showFirstname is not None:
	   self.showFirstname = showFirstname

	if lastname is not None:
	   self.lastname = lastname

	if showLastname is not None:
	   self.showLastname = showLastname

	if job_title is not None:
	   self.job_title = job_title

	if showJobtitle is not None:
	   self.showJobtitle = showJobtitle

	if company is not None:
	   self.company = company

	if showCompany is not None:
	   self.showCompany = showCompany

	if file_as is not None:
	   self.file_as = file_as
	   
	if showFileAs is not None:
	    self.showFileAs = showFileAs

	if address is not None:
	   self.address = address

	if showAddress is not None:
	   self.showAddress = showAddress

	if phone is not None:
	   self.phone = phone

	if showPhone is not None:
	   self.showPhone = showPhone

	if pri_email is not None:
	   self.pri_email = pri_email

	if showPriemail is not None:
	   self.showPriemail = showPriemail
	
	if sec_email is not None:
	   self.sec_email = sec_email

	if showSecemail is not None:
	   self.showSecemail = showSecemail
	
	if ter_email is not None:
	   self.ter_email = ter_email

	if showTeremail is not None:
	   self.showTeremail = showTeremail
	    
	if homepage is not None:
	   if len(homepage) != 0:
	      str = 'http://'
	      ishttp = string.find(homepage, str)
	      if ishttp == -1:
	         homepage = 'http://' + homepage
	      self.homepage = homepage

	if showHomepage is not None:
	   self.showHomepage = showHomepage

def addContact(self, id, title='', REQUEST=None):
    ob=Contact(id,title)
    self._setObject(id, ob)

Globals.InitializeClass(Contact)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(Contact,
                      constructors=(addContact,),
		      action='contact_edit_form',
		      icon='profile_icon.gif')
