##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Manage portal'

#Globals
import Globals
import zLOG
import string
from AccessControl import ClassSecurityInfo
from DateTime.DateTime import DateTime

#CMF
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl

factory_type_information = {
      'id': 'Reference',
      'meta_type': 'PIM Reference',
      'description': 'Use reference object to store reference data. Only admins should add this',
      'product': 'OnlinePIM',
      'icon': 'profile_icon.gif',
      'factory': 'addReference',
      'filter_content_types': 0,
      'immediate_view': 'reference_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'reference_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'reference_edit_form',
		'permissions': ('Modify portal content',),
		'category': 'object'})
       }


class Reference( PortalContent
          , DefaultDublinCoreImpl
          ):
    """
        A Reference
    """

    meta_type='PIM Reference'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1

    security = ClassSecurityInfo()

    #Dumme values :-(
    contact_tname = ''
    company = ''
    address = ''
    phone = ''
    contact_email = ''
    homepage = ''
    picpath = ''

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
        self.description=description
	self.contact_name = ''
	self.company = ''
	self.address = ''
	self.phone = ''
	self.contact_email = ''
	self.homepage = ''
	self.picpath = ''

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    security.declareProtected(ManageProperties, 'edit')
    def edit(self, title=None, description=None, contact_name=None, company=None, address=None, phone=None, contact_email=None, homepage=None, picpath=None):

	if title is not None:
	   self.setTitle(title)

	if description is not None:
	   self.setDescription(description)

	if contact_name is not None:
	   self.contact_name = contact_name

	if company is not None:
	   self.company = company

	if address is not None:
	   self.address = address

	if phone is not None:
	   self.phone = phone

	if contact_email is not None:
	   self.contact_email = contact_email
	
	if homepage is not None:
	      if len(homepage) != 0:
	         str = 'http://'
	         ishttp = string.find(homepage, str)
	         if ishttp == -1:
	            homepage = 'http://' + homepage
	         self.homepage = homepage

	if picpath is not None:
	   self.picpath = picpath

def addReference(self, id, title='', REQUEST=None):
	ob = Reference(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(Reference)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(Reference,
                      constructors=(addReference,),
		      action='reference_edit_form',
		      icon='profile_icon.gif')
