##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

"""Basic portal calendar tool.
$Id: CalendarTool.py,v 1.7 2002/03/19 13:47:40 john Exp $
"""
__version__='$Revision: 1.7 $'

from Interface import Attribute, Base

class CalendarTool( Base ):

    """
    A tool for displaying months and dates
    """
    
    def setDisplayMode(self, mode):
        """
            Sets the display mode for the calendar.
            The options are 'All items' or 'Own items'
        """

    def getUserMode(self, object):
        """
            Returns the display mode for a specific object (usually this would be the desktop).
            The options are 'All items' or 'Own items'
        """
    
    def setCalendarTypes(self, types):
        """
            Set which portal types should be displayed in the calendar
        """
                
    def getCalendarTypes(self):
        """
            Return the list of portal types that should be displayed in the calendar.
        """
        
    def queryCatalog(self, date, object):
        """
            Returns a list of 'brains' objects from the portal catalog based on the portal types and display mode selected by the user.
        """

    def getPrevDate(self, date=None, mode='month'):
        """
            Return the previous date in the listing (a 'go back'function)
        """

    def getNextDate(self, date=None, mode='month'):
        """
            Return the next date in the listing (a 'go forward' function)
        """

    def getHeadline(self, date=None, mode='month'):
        """
            Return the headline for the calendar.
        """
    
    def getDateList(self, date=None, mode='month'):
        """
            The date argument will contain the date you want a list of dates for. If date is None, today will be used.
            The mode argument will contain the mode you want a list of dates for. Mode is default set to month.
            'day' are also acceptable mode.
        """

    def getMonthRange(self, date=None):
        """
            Return the range for the month (firstdate, lastdate).
            Return as a tuple.
        """
