from DateTime import DateTime
import os, Globals
from Globals import package_home
import random
import re
import regsub
import zLOG

_dtmldir = os.path.join(package_home(globals()), 'dtml')
LiteralString = re.compile(r'\s*\{(?P<Size>\d+)\}(?P<Rest>.*)')
QuotedString = re.compile(r'\s*"(?P<String>.*?[^\\](?="))"(?P<Rest>.*)')
ListOpen = re.compile(r'\s*\((?P<Rest>.*)')
ListClose = re.compile(r'\s*\)(?P<Rest>.*)')
Atom = re.compile(r'\s*(?P<Atom>\\?[\w\[\]\.-]+)(?P<Rest>.*)')
Number = re.compile(r'\s*(?P<Number>\\?[\d]+)(?P<Rest>.*)')
NIL = re.compile(r'\s*(?P<NIL>NIL)(?P<Rest>.*)')

def getUniqueId():
    time = str(DateTime().millis()) + str(random.randint(0, 1000000))
    return time

def CreateStruct(data):
    c = []
    s = [c]
    newrec = 1
    correct = []
    while data:
        if newrec:
            c = s[0]
            n = []
            c.append(n)
            c = n
        newrec = 1
        if type(data[0]) == type(()):
            conts = data[0]
        else:
            conts = [data[0]]
        data = data[1:]
        while conts:
            line = conts[0]
            conts = conts[1:]
            while line != '':
                m = QuotedString.match(line)
                if m:
                    cur_string = m.group('String')
                    cur_string = regsub.gsub(r'\\"', '"', cur_string)
                    c.append(cur_string)
                    line = m.group('Rest')
                    continue
                m = ListOpen.match(line)
                if m:
                    n = []
                    c.append(n)
                    s.append(c)
                    c = n
                    line = m.group('Rest')
                    continue
                m = ListClose.match(line)
                if m:
                    c = s[-1]
                    s = s[:1]
                    line = m.group('Rest')
                    continue
                m = NIL.match(line)
                if m:
                    c.append(None)
                    line = m.group('Rest')
                    continue
                m = Number.match(line)
                if m:
                    c.append(int(m.group('Number')))
                    line = m.group('Rest')
                    continue
                m = Atom.match(line)
                if m:
                    c.append(m.group('Atom'))
                    line = m.group('Rest')
                    continue
                m = LiteralString.match(line)
                if m:
                    try:
                        line=conts[0]
                        conts=conts[1:]
                        c.append(line)
                    except:
                        pass
                    line = ""
                    newrec = 0
                    continue
                else:
                    correct.append(line[1:])
                    line = ""
                    newrec = 0
    c = s[0]
    return c, correct

